#
# tcl / tk program to make the kernel configuration AND compilation by menu
#
# (C) 1997-98, SuSE GmbH, Nuremberg, dey
# written by Martin Scherbaum <maddin@suse.de>
# this program is GPL
#

set language en
if { $argc > 0 } { set language [lindex $argv 0] }

proc noNewConfigProc { } {

    set configtime [file mtime /usr/src/linux/.config]
    set susewmtime [file mtime /usr/src/linux/susewm]

    if { $susewmtime > $configtime } {

	frame .main 
	
	text  .main.text

	frame .main.btns
    }
}

# noNewConfigProc

set action(zimage)       1
set action(zlilo)        0
set action(modules)      1
set action(modulesi)     0
set action(clean)        1
set action(depend)       1
set action(mrproper)     0

set tmp(zimage)          0

set text(de,window)    "Kernel erstellen"
set text(de,title)     "Einstellungen zum Kernel-Kompilieren"
set text(de,zimage)    "Kernel generieren (make bzImage), empfohlen"
set text(de,zlilo)     "LILO einrichten (make zlilo)"
set text(de,modules)   "Module compilieren (make modules), empfohlen"
set text(de,modulesi)  "Module installieren  (make modules_install), empfohlen"
set text(de,depend)    "Abhngigkeiten berprfen (make dep), empfohlen"
set text(de,clean)     "Vor Kompilieren Objektdateien lschen (make clean), empfohlen"
set text(de,mrproper)  "Alles aufrumen, auch Konfigurationsdaten (make mrproper), nicht empfohlen"
set text(de,cancel)    "Abbrechen"
set text(de,ok)        "Beenden und Kompilieren"
set text(de,log)       "Ausgaben in /usr/src/linux/compile.log protokollieren"

set text(en,window)   "Build a kernel"
set text(en,title)    "Options for Kernel compiling"
set text(en,zimage)   "Build kernel (make bzImage), recommended"
set text(en,zlilo)    "Setup lilo (make zlilo)"
set text(en,modules)  "Build modules (make modules), recommended"
set text(en,modulesi) "Install modules (make modules_install), recommended"
set text(en,depend)   "Check dependencies (make dep), recommended"
set text(en,clean)    "Remove object files before compiling (make clean), recommended"
set text(en,mrproper) "Clean everything, even configuration data (make mrproper), not recommended"
set text(en,cancel)   "Cancel"
set text(en,ok)       "Quit and Compile"
set text(en,log)      "Log output in /usr/src/linux/compile.log"

set text(fr,window)    "Construction du Noyeau"
set text(fr,title)     "Configurations au compilage du noyeau"
set text(fr,zimage)    "Gnrer un Noyeau (make bzImage), recommand"
set text(fr,zlilo)     "tablir LILO (make zlilo)"
set text(fr,modules)   "Compiler des Modules (make modules), recommand"
set text(fr,modulesi)  "Installer des Modules  (make modules_install), recommand"
set text(fr,depend)    "Verifier des dpendances (make dep), recommand"
set text(fr,clean)     "ffacer fichiers objets avant la compilation (make clean), recommand"
set text(fr,mrproper)  "ffacer tout, aussi fichiers de configuration (make mrproper), ne pas recommand"
set text(fr,cancel)    "Annuler"
set text(fr,ok)        "Quitter et Compiler"
set text(fr,log)       "Protocoller des issues de compilage dans /usr/src/linux/compile.log"

set text(it,window)   "Build a kernel"
set text(it,title)    "Options for Kernel compiling"
set text(it,zimage)   "Build kernel (make bzImage), recommended"
set text(it,zlilo)    "Setup lilo (make zlilo)"
set text(it,modules)  "Build modules (make modules), recommended"
set text(it,modulesi) "Install modules (make modules_install), recommended"
set text(it,depend)   "Check dependencies (make dep), recommended"
set text(it,clean)    "Remove object files before compiling (make clean), recommended"
set text(it,mrproper) "Clean everything, even configuration data (make mrproper), not recommended"
set text(it,cancel)   "Cancel"
set text(it,ok)       "Quit and Compile"
set text(it,log)      "Log output in /usr/src/linux/compile.log"

frame .main

set lf [ \
	frame .main.lf \
	-bd 2 -relief raised \
	]

set lf1 [\
	frame $lf.lf1 \
	-relief sunken -bd 2 \
	]

label $lf1.label -text $text($language,title)


foreach btn { 1 2 3 5 } {

    set bf$btn [ \
	    frame .main.btns$btn \
	    -bd 2 -relief raised \
	    ]
}

foreach btn { zimage modules modulesi zlilo } {

    set but($btn) [\
	    checkbutton $bf1.$btn \
	    -text $text($language,$btn) \
	    -variable action($btn) \
	    -command checkValid \
	    ]
}

foreach btn { depend clean } {

    set but($btn) [\
	    checkbutton $bf2.$btn \
	    -text $text($language,$btn)  \
	    -variable action($btn) \
	    -command checkValid \
	    ]
}

set but(mrproper) [\
	checkbutton $bf3.mrproper \
	-text $text($language,mrproper)  \
	-variable action(mrproper) \
	    -command checkValid \
	]

set af [frame .main.action -bd 2 -relief raised]

set of [frame $af.okf     -bd 1 -relief sunken]
set cf [frame $af.cancelf -bd 0 -relief flat]

button $of.ok \
	-text $text($language,ok)  \
	-command quitProc \
	-underline 0 

button $cf.cancel \
	-text $text($language,cancel)  \
	-command { exit 1 } \
	-underline 0


pack $lf1.label \
	-side top \
	-expand yes -fill x \
	-padx 2m -pady 2m

pack $lf \
	-side top \
	-fill x

pack $lf1 \
	-side top \
	-fill x \
	-padx 2m -pady 2m

pack $bf1.zimage $bf1.modules $bf1.modulesi $bf1.zlilo \
	-side top -anchor w \
	-padx 2m -pady 1m 


pack $bf2.depend $bf2.clean \
	-side top -anchor w \
	-padx 2m  -pady 1m 


pack $bf3.mrproper \
	-side top -anchor w \
	-padx 2m  -pady 1m 

pack $bf1 $bf2 $bf3 \
	-side top \
	-fill x

pack $bf5 \
	-side top \
	-expand yes -fill both

pack $of.ok $cf.cancel \
	-side left \
	-fill x \
	-padx 1m -pady 1m

pack $of $cf \
	-side left \
	-expand yes \
	-padx 2m -pady 2m 


pack $af \
	-side top \
	-fill x 

pack .main \
	-expand yes -fill both

bind all <Return> quitProc

switch "$language" {

    de {
	bind all <Any-b>    quitProc
	bind all <Any-a>    { exit 1 }
    }

    fr {
	bind all <Any-q>    quitProc
	bind all <Any-a>    { exit 1 }
    }

    it {
	bind all <Any-q>    quitProc
	bind all <Any-c>    { exit 1 }
    }

    default {
	bind all <Any-q>    quitProc
	bind all <Any-c>    { exit 1 }
    }
}

bind all <Escape>   { exit 1 }

trace variable action(mrproper) w mrproperProc 

proc checkValid { } {

    global action of

    set found 0
    foreach variable { zimage modules modulesi zlilo depend clean mrproper } {

	if $action($variable) {

	    set found 1
	    break
	}
    }

    if $found {

	$of.ok configure -state normal

    } else {

	$of.ok configure -state disabled
    }
}

proc mrproperProc { name elem operation } {

    global action 
    global but
    global tmp

    set elemlist [array names but]
    set elemind  [ lsearch $elemlist "mrproper" ]
    set elemlist [ lreplace $elemlist $elemind $elemind ]

    if { $action(mrproper) == 1 } {
	
	foreach elem  $elemlist {
	    set tmp($elem) $action($elem)
	    set action($elem) 0
	    $but($elem) configure -state disabled
	}

    } else {
	
	foreach elem $elemlist {
	    $but($elem) configure -state active
	    set action($elem) $tmp($elem)
	    set tmp($elem) 0
	}
    }
}

proc quitProc { } {

    global action

    if { $action(mrproper) == 1 } {

	puts "make mrproper"
	exit 0
    }

    set makestring "make"
    
    if $action(depend) {

	set makestring [format "%s dep" $makestring]
    }

    if $action(clean) {

	set makestring [format "%s clean" $makestring]
    }

    if $action(zlilo) {

	set makestring [format "%s zlilo" $makestring]

    } else {

	if $action(zimage) {

	    set makestring [format "%s bzImage" $makestring]
	}
    }

    if $action(modules) {

	set makestring [format "%s modules" $makestring]
    }

    if $action(modulesi) {

	set makestring [format "%s modules_install" $makestring]
    }

    if { $makestring == "make" } {

	exit 0
    }

    puts $makestring

    exit 0
}

wm title . $text($language,window)

cd /usr/src/linux






